using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace DataGridView_PopUpEdit
{
    public partial class Form1 : Form
    {
        private ToolStripDropDown _tsdd;
        private bool _dropDownClosed;
        private string _formattedValue;
        private ToolStripControlHost _tbh;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this._dgv.Rows.Add(4);
            this._dgv.Rows[0].Cells[0].Value = "ConstrainedCopy";
            this._dgv.Rows[0].Cells[1].Value = "Copies a range of elements from an Array starting at the specified source index and pastes them to another Array starting at the specified destination index. Guarantees that all changes are undone if the copy does not succeed completely.";
            this._dgv.Rows[1].Cells[0].Value = "Find";
            this._dgv.Rows[1].Cells[1].Value = "Searches for an element that matches the conditions defined by the specified predicate, and returns the first occurrence within the entire Array.";
            this._dgv.Rows[2].Cells[0].Value = "IndexOf";
            this._dgv.Rows[2].Cells[1].Value = "Overloaded. Returns the index of the first occurrence of a value in a one-dimensional Array or in a portion of the Array.";
            this._dgv.Rows[3].Cells[0].Value = "TrueForAll";
            this._dgv.Rows[3].Cells[1].Value = "Determines whether every element in the array matches the conditions defined by the specified predicate.";
        }

        private void _dgv_EditingControlShowing(object sender, DataGridViewEditingControlShowingEventArgs e)
        {
            if(this._dgv.CurrentCell.ColumnIndex != 1)
                return;
            this._dropDownClosed = false;
            Point c = this._dgv.CurrentCellAddress;
            int heightOfRow = this._dgv.Rows[this._dgv.CurrentCell.RowIndex].Height;
            Rectangle recOfCell = this._dgv.GetCellDisplayRectangle(c.X, c.Y, true);
            this._formattedValue = this._dgv[c.X, c.Y].FormattedValue.ToString();

            this._tsdd = new ToolStripDropDown();
            this._tsdd.Opened += new EventHandler(_tsdd_Opened);
            this._tsdd.AutoSize = true;

            TextBox tb = new TextBox();
            tb.Multiline = true;
            tb.Text = _formattedValue;
            tb.AcceptsReturn = true;

            this._tbh = new ToolStripControlHost(tb, "textbox");
            this._tbh.Padding = new Padding(0);
            this._tbh.AutoSize = false;
            this._tbh.Size = new Size(300, 100);

            this._tsdd.Items.Add(_tbh);
            this._tsdd.Padding = new Padding(0);
            this._tsdd.Closing += new ToolStripDropDownClosingEventHandler(_tsdd_Closing);
            this._tsdd.Show(this._dgv, recOfCell.Location);

            while(!this._dropDownClosed)
            {
                Application.DoEvents();
            }

            this._dgv.BeginInvoke((MethodInvoker)delegate()
            {
                this._dgv.EndEdit();
                this._dgv[c.X, c.Y].Value = this._formattedValue;
            });
        }

        void _tsdd_Closing(object sender, ToolStripDropDownClosingEventArgs e)
        {
            this._formattedValue = this._tsdd.Items[0].Text;
            this._dropDownClosed = true;
        }

        void _tsdd_Opened(object sender, EventArgs e)
        {
            this._tbh.Focus();
        }
    }
}