using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace RenameInPlace_ColumnHeader
{
    public partial class Form1 : Form
    {
        private TextBox _tb;
        private bool _enteringString = false;

        public Form1()
        {
            InitializeComponent();
            this._lb.Text = "Double-click on 'Color' header and enter value to search...";
            this._tb = new TextBox();
            this._tb.BorderStyle = BorderStyle.None;
            this._tb.Visible = false;
            this._dgv.Controls.Add(this._tb);
        }

        public bool EnteringString { get { return this._enteringString; } }
        
        private void Form1_Load(object sender, EventArgs e)
        {
            this._dgv.Rows.Add("Apple", "Green", false);
            this._dgv.Rows.Add("Pear", "Goldish", true); 
            this._dgv.Rows.Add("Watermelon", "Red", false);
            this._dgv.Rows.Add("Grape", "Purple", true);
            this._dgv.Rows.Add("Orange", "Orange", true);
            this._dgv.Rows.Add("Banana", "Yellow", false);
            this._dgv.Rows.Add("Cherry", "Cherry", false);
        }

        private void _dgv_ColumnHeaderMouseDoubleClick(object sender, DataGridViewCellMouseEventArgs e)
        {
            if(e.ColumnIndex != 1 || this._enteringString)
                return;
            Rectangle rec = this._dgv.GetCellDisplayRectangle(1, -1, false);
            this._tb.Width = rec.Width - 2;
            this._tb.Top = rec.Top + 3;
            this._tb.Left = rec.Left + 1;
            this._tb.Visible = true;
            this._tb.Capture = true;
            this._tb.Focus();
            this._tb.MouseDown += new MouseEventHandler(_tb_MouseDown);
            this._tb.KeyDown += new KeyEventHandler(_tb_KeyDown);
            this._tb.LostFocus += new EventHandler(_tb_LostFocus);
            this._enteringString = true;
        }

        void _tb_LostFocus(object sender, EventArgs e)
        {
            if(this._enteringString)
                this.CommitAndSearch();
        }

        void _tb_KeyDown(object sender, KeyEventArgs e)
        {
            if(e.KeyData == Keys.Enter)
                this.CommitAndSearch();
            else if(e.KeyData == Keys.Escape)
                this.JustDiscard();
        }

        void _tb_MouseDown(object sender, MouseEventArgs e)
        {
            if(this._tb.Capture)
            {
                Point clnLoc = new Point(e.X, e.Y);
                if(!this._tb.ClientRectangle.Contains(clnLoc))
                    this.CommitAndSearch();
            }
        }

        private void CommitAndSearch()
        {
            string search = this._tb.Text;
            this._tb.Capture = false;
            this._tb.Visible = false;
            this._enteringString = false;

            foreach(DataGridViewRow row in this._dgv.Rows)
            {
                if(row.Cells["Color"].Value.ToString() == search)
                {
                    this._dgv.CurrentCell = row.Cells["Color"];
                    break;
                }
            }
        }

        private void JustDiscard()
        {
            this._tb.Capture = false;
            this._tb.Visible = false;
            this._enteringString = false;
        }

        public void EnterFromGrid()
        {
            this._tb_KeyDown(this._tb, new KeyEventArgs(Keys.Enter));
        }
    }
}